Telerik.Web.UI.RadComboBoxEventArgs=function(e){
Telerik.Web.UI.RadComboBoxEventArgs.initializeBase(this);
this._domEvent=e;
};
Telerik.Web.UI.RadComboBoxEventArgs.prototype={get_domEvent:function(){
return this._domEvent;
}};
Telerik.Web.UI.RadComboBoxEventArgs.registerClass("Telerik.Web.UI.RadComboBoxEventArgs",Sys.EventArgs);
Telerik.Web.UI.RadComboBoxCancelEventArgs=function(e){
Telerik.Web.UI.RadComboBoxCancelEventArgs.initializeBase(this);
this._domEvent=e;
};
Telerik.Web.UI.RadComboBoxCancelEventArgs.prototype={get_domEvent:function(){
return this._domEvent;
}};
Telerik.Web.UI.RadComboBoxCancelEventArgs.registerClass("Telerik.Web.UI.RadComboBoxCancelEventArgs",Sys.CancelEventArgs);
Telerik.Web.UI.RadComboBoxItemEventArgs=function(_3,e){
Telerik.Web.UI.RadComboBoxItemEventArgs.initializeBase(this);
this._item=_3;
this._domEvent=e;
};
Telerik.Web.UI.RadComboBoxItemEventArgs.prototype={get_item:function(){
return this._item;
},get_domEvent:function(){
return this._domEvent;
}};
Telerik.Web.UI.RadComboBoxItemEventArgs.registerClass("Telerik.Web.UI.RadComboBoxItemEventArgs",Sys.EventArgs);
Telerik.Web.UI.RadComboBoxItemCancelEventArgs=function(_5,e){
Telerik.Web.UI.RadComboBoxItemCancelEventArgs.initializeBase(this);
this._item=_5;
this._domEvent=e;
};
Telerik.Web.UI.RadComboBoxItemCancelEventArgs.prototype={get_item:function(){
return this._item;
},get_domEvent:function(){
return this._domEvent;
}};
Telerik.Web.UI.RadComboBoxItemCancelEventArgs.registerClass("Telerik.Web.UI.RadComboBoxItemCancelEventArgs",Sys.CancelEventArgs);
Telerik.Web.UI.RadComboBoxRequestEventArgs=function(_7,e){
Telerik.Web.UI.RadComboBoxRequestEventArgs.initializeBase(this);
this._text=_7;
this._domEvent=e;
};
Telerik.Web.UI.RadComboBoxRequestEventArgs.prototype={get_text:function(){
return this._text;
},get_domEvent:function(){
return this._domEvent;
}};
Telerik.Web.UI.RadComboBoxRequestEventArgs.registerClass("Telerik.Web.UI.RadComboBoxRequestEventArgs",Sys.EventArgs);
Telerik.Web.UI.RadComboBoxRequestCancelEventArgs=function(_9,_a,e){
Telerik.Web.UI.RadComboBoxRequestCancelEventArgs.initializeBase(this);
this._text=_9;
this._context=_a;
this._domEvent=e;
};
Telerik.Web.UI.RadComboBoxRequestCancelEventArgs.prototype={get_text:function(){
return this._text;
},get_context:function(){
return this._context;
},get_domEvent:function(){
return this._domEvent;
}};
Telerik.Web.UI.RadComboBoxRequestCancelEventArgs.registerClass("Telerik.Web.UI.RadComboBoxRequestCancelEventArgs",Sys.CancelEventArgs);
Telerik.Web.UI.RadComboBoxItemsRequestFailedEventArgs=function(_c,_d,e){
Telerik.Web.UI.RadComboBoxItemsRequestFailedEventArgs.initializeBase(this);
this._text=_c;
this._errorMessage=_d;
this._domEvent=e;
};
Telerik.Web.UI.RadComboBoxItemsRequestFailedEventArgs.prototype={get_text:function(){
return this._text;
},get_errorMessage:function(){
return this._errorMessage;
},get_domEvent:function(){
return this._domEvent;
}};
Telerik.Web.UI.RadComboBoxItemsRequestFailedEventArgs.registerClass("Telerik.Web.UI.RadComboBoxItemsRequestFailedEventArgs",Telerik.Web.UI.RadComboBoxCancelEventArgs);
Type.registerNamespace("Telerik.Web.UI");
Telerik.Web.UI.Keys=function(){
};
Telerik.Web.UI.Keys.prototype={Shift:16,Escape:27,Up:38,Down:40,Left:37,Right:39,Enter:13,Tab:9,Space:32,PageUp:33,Del:46,F1:112,F12:123};
Telerik.Web.UI.Keys.registerEnum("Telerik.Web.UI.Keys");
Telerik.Web.UI.RadComboBox=function(_f){
Telerik.Web.UI.RadComboBox.initializeBase(this,[_f]);
this._changeText=true;
this._children=null;
this._virtualScroll=true;
this._itemData=null;
this._selectedItem=null;
this._selectedIndex=null;
this._highlightedItem=null;
this._dropDownVisible=false;
this._enableLoadOnDemand=false;
this._openDropDownOnLoad=false;
this._appendItems=false;
this._allowCustomText=false;
this._markFirstMatch=false;
this._originalText=this.get_inputDomElement().value;
this._cachedText=this._originalText;
this._text="";
this._value=null;
this._isCaseSensitive=false;
this._autoCompleteSeparator=null;
this._postBackReference=null;
this._dropDownElement=null;
this._inputDomElement=null;
this._imageDomElement=null;
this._tableElement=null;
this._itemRequestTimeout=300;
this._isTemplated=false;
this._requestTimeoutID=0;
this._highlightTemplatedItems=false;
this._clientState={value:"",text:"",enabled:true,logEntries:[]};
this._uniqueId=null;
this._rightToLeft=false;
this._isDetached=false;
this._offsetX=0;
this._offsetY=0;
this._overlay=null;
this._enableScreenBoundaryDetection=true;
this._suppressChange=false;
this._lastKeyCode=null;
this._loadingDiv=null;
this._loadingMessage="Loading...";
this._showMoreResultsBox=false;
this._closeDropDownOnBlur=true;
this._focused=false;
this._causesValidation=true;
this.get_inputDomElement().setAttribute("autocomplete","off");
this._errorMessage="CallBack Error!";
this._showMoreMessage="";
this._webServiceSettings=new Telerik.Web.UI.WebServiceSettings({});
this._webServiceLoader=null;
this._clientDataString=null;
this._scrollbarWidth=16;
this._enabled=true;
this._fireEvents=this._enabled;
this._slide=null;
this._expandAnimation=new Telerik.Web.UI.AnimationSettings({});
this._expandDelay=100;
this._collapseAnimation=new Telerik.Web.UI.AnimationSettings({});
this._collapseDelay=500;
this._slideDirection=Telerik.Web.UI.SlideDirection.Down;
this._expandAnimationEndedDelegate=null;
this._expandAnimationStartedDelegate=null;
this._showDropDownOnTextboxClick=true;
this._dropDownWidth="";
this._height="";
this._childListElementWrapper=null;
this._skin="";
this._skipLoadingItems=false;
this._ajaxRequest=false;
this._endOfItems=false;
this._isInPostBack=false;
this._emptyMessage=null;
};
Telerik.Web.UI.RadComboBox.ComboBoxes=[];
Telerik.Web.UI.RadComboBox._createChildControls=function(_10,_11){
var _12=_10.get_itemData();
if(!_12){
return;
}
var _13=_10.get_childListElement();
if(!_13){
return;
}
var _14=$telerik.getChildrenByTagName(_10.get_childListElement(),"li");
var _15=_14.length;
var _16=0;
if(_14.length>0&&_14[0].className=="rcbLoading"){
_15=_15-1;
_16=1;
}
Sys.Debug.assert(_12.length==_15,"Length of elements and json must be the same!");
for(var i=_16;i<_14.length;i++){
var _18=new Telerik.Web.UI.RadComboBoxItem();
_11.add(_18);
_18._initialize(_12[i-_16],_14[i]);
}
};
Telerik.Web.UI.RadComboBox.prototype={initialize:function(){
Telerik.Web.UI.RadComboBox.callBaseMethod(this,"initialize");
this._clientState.value=this._value;
this._clientState.text=this._text;
this.updateClientState();
if(this._requiresRightToLeft()){
this._initRightToLeft();
}
if(this.get_childListElement()){
this._onDropDownClickDelegate=Function.createDelegate(this,this._onDropDownClick);
$addHandler(this.get_childListElement(),"click",this._onDropDownClickDelegate);
this._onDropDownHoverDelegate=Function.createDelegate(this,this._onDropDownHover);
$addHandler(this.get_childListElement(),"mouseover",this._onDropDownHoverDelegate);
$addHandler(this.get_childListElement(),"selectstart",this._cancelEvent);
$addHandler(this.get_childListElement(),"dragstart",this._cancelEvent);
this._onDropDownOutDelegate=Function.createDelegate(this,this._onDropDownOut);
$addHandler(this.get_childListElement(),"mouseout",this._onDropDownOutDelegate);
}
this._onTableHoverDelegate=Function.createDelegate(this,this._onTableHover);
$addHandler(this.get_tableElement(),"mouseover",this._onTableHoverDelegate);
this._onTableOutDelegate=Function.createDelegate(this,this._onTableOut);
$addHandler(this.get_tableElement(),"mouseout",this._onTableOutDelegate);
this._onPropertyChangeDelegate=Function.createDelegate(this,this._onInputPropertyChange);
$addHandler(this.get_inputDomElement(),"propertychange",this._onPropertyChangeDelegate);
this._onFocusDelegate=Function.createDelegate(this,this._onFocus);
$addHandler(this.get_inputDomElement(),"focus",this._onFocusDelegate);
this._onDocumentClickDelegate=Function.createDelegate(this,this._onDocumentClick);
if($telerik.isIE){
document.attachEvent("onmousedown",this._onDocumentClickDelegate);
document.attachEvent("oncontextmenu",this._onDocumentClickDelegate);
}else{
$addHandler(document,"mousedown",this._onDocumentClickDelegate);
$addHandler(document,"contextmenu",this._onDocumentClickDelegate);
}
this._onDropDownScrollDelegate=Function.createDelegate(this,this._onDropDownScroll);
$addHandler(this.get_childListElementWrapper(),"scroll",this._onDropDownScrollDelegate);
this._eventMap.addHandlerForClassName("click","rcbInput",this._onInputClick);
this._eventMap.addHandlerForClassName("keydown","rcbInput",this._onKeyDown);
if(!$telerik.isIE){
this._eventMap.addHandlerForClassName("input","rcbInput",this._onInputChange);
}
if(this.get_imageDomElement()){
this._onImageClickDelegate=Function.createDelegate(this,this._onImageClick);
$addHandler(this.get_imageDomElement(),"click",this._onImageClickDelegate);
}
this._onWindowResizeDelegate=Function.createDelegate(this,this._onWindowResize);
$addHandler(window,"resize",this._onWindowResizeDelegate);
if(this._openDropDownOnLoad){
this._onOpenOnLoad=Function.createDelegate(this,this.showDropDown);
$addHandler(window,"load",this._onOpenOnLoad);
}
if(this.get_moreResultsBoxElement()){
this._onMoreResultsBoxClickDelegate=Function.createDelegate(this,this._onMoreResultsBoxClick);
$addHandler(this.get_moreResultsBoxElement(),"click",this._onMoreResultsBoxClickDelegate);
this._onMoreResultsBoxOverDelegate=Function.createDelegate(this,this._onMoreResultsBoxOver);
$addHandler(this.get_moreResultsBoxElement(),"mouseover",this._onMoreResultsBoxOverDelegate);
this._onMoreResultsBoxOutDelegate=Function.createDelegate(this,this._onMoreResultsBoxOut);
$addHandler(this.get_moreResultsBoxElement(),"mouseout",this._onMoreResultsBoxOutDelegate);
}
var _19=this.findItemByText(this._text);
if(_19&&!_19.get_isSeparator()){
this.set_selectedItem(_19);
}
this._initializeAnimation();
if(this._openDropDownOnLoad&&!this.get_dropDownVisible()){
this.showDropDown();
}
var me=this;
this._beforePostbackHandler=Function.createDelegate(this,this._backUpDropDown);
Telerik.Web.UI.PostbackWrapper.add_beforePostback(this._beforePostbackHandler);
Array.add(Telerik.Web.UI.RadComboBox.ComboBoxes,this);
if(this._fireEvents){
this.raiseEvent("load",null);
}
if(Sys.WebForms&&Sys.WebForms.PageRequestManager){
this._endRequestHandler=Function.createDelegate(this,this._onEndRequest);
Sys.WebForms.PageRequestManager.getInstance().add_endRequest(this._endRequestHandler);
}
this.get_element().value=this._text;
var _1b=this.get_element().style.zIndex;
var _1c=this.get_dropDownElement().parentNode.style.zIndex;
if(_1b==0){
_1b=_1c;
}
this.get_dropDownElement().parentNode.style.zIndex=_1b;
},_initializeAnimation:function(){
var _1d=this._getAnimatedElement();
if(_1d){
this._slide=new Telerik.Web.UI.Slide(_1d,this.get_expandAnimation(),this.get_collapseAnimation());
this._slide.initialize();
this._slide.set_direction(this.get_slideDirection());
}
this._expandAnimationEndedDelegate=Function.createDelegate(this,this._onExpandAnimationEnded);
this._slide.add_expandAnimationEnded(this._expandAnimationEndedDelegate);
this._expandAnimationStartedDelegate=Function.createDelegate(this,this._onExpandAnimationStarted);
this._slide.add_expandAnimationStarted(this._expandAnimationStartedDelegate);
},_onExpandAnimationEnded:function(_1e,e){
if(window.netscape&&!window.opera){
this.get_childListElementWrapper().style.overflow="auto";
if(this.get_selectedItem()){
this.get_selectedItem().scrollOnTop();
}
}
},_onExpandAnimationStarted:function(_20,e){
if(window.netscape&&!window.opera){
this.get_childListElementWrapper().style.overflow="hidden";
}
},_requiresRightToLeft:function(){
var _22=this.get_element();
while(_22.nodeType!==9){
if(_22.dir=="rtl"){
return true;
}
_22=_22.parentNode;
}
return false;
},_initRightToLeft:function(){
this._rightToLeft=true;
if(this._skin){
this.get_element().className=String.format("{0} RadComboBox_{1}_rtl",this.get_element().className,this._skin);
this.get_dropDownElement().className=String.format("{0} RadComboBoxDropDown_{1}_rtl",this.get_dropDownElement().className,this._skin);
}
if(this.get_imageDomElement()){
if(Sys.UI.DomElement.containsCssClass(this.get_imageDomElement().parentNode,"rcbArrowCellRight")){
this._replaceCssClass(this.get_imageDomElement().parentNode,"rcbArrowCellRight","rcbArrowCellLeft");
this.get_inputDomElement().parentNode.className="rcbInputCell rcbInputCellRight";
}else{
this._replaceCssClass(this.get_imageDomElement().parentNode,"rcbArrowCellLeft","rcbArrowCellRight");
this.get_inputDomElement().parentNode.className="rcbInputCell rcbInputCellLeft";
}
}
},_replaceCssClass:function(_23,_24,_25){
_23.className=_23.className.replace(_24,_25);
},dispose:function(){
this._originalDomPositionHelper=null;
if(Sys.WebForms&&Sys.WebForms.PageRequestManager){
Sys.WebForms.PageRequestManager.getInstance().remove_endRequest(this._endRequestHandler);
}
Array.remove(Telerik.Web.UI.RadComboBox.ComboBoxes,this);
Telerik.Web.UI.PostbackWrapper.remove_beforePostback(this._beforePostbackHandler);
Telerik.Web.UI.RadComboBox.callBaseMethod(this,"dispose");
if(this._expandAnimationEndedDelegate){
if(this._slide){
this._slide.remove_expandAnimationEnded(this._expandAnimationEndedDelegate);
}
this._expandAnimationEndedDelegate=null;
}
if(this._expandAnimationStartedDelegate){
if(this._slide){
this._slide.remove_expandAnimationStarted(this._expandAnimationStartedDelegate);
}
this._expandAnimationStartedDelegate=null;
}
$removeHandler(window,"resize",this._onWindowResizeDelegate);
$removeHandler(this.get_inputDomElement(),"propertychange",this._onPropertyChangeDelegate);
$removeHandler(this.get_inputDomElement(),"focus",this._onFocusDelegate);
if($telerik.isIE){
document.detachEvent("onmousedown",this._onDocumentClickDelegate);
document.detachEvent("oncontextmenu",this._onDocumentClickDelegate);
}else{
$removeHandler(document,"mousedown",this._onDocumentClickDelegate);
$removeHandler(document,"contextmenu",this._onDocumentClickDelegate);
}
if(this.get_childListElement()){
$removeHandler(this.get_childListElement(),"click",this._onDropDownClickDelegate);
$removeHandler(this.get_childListElement(),"mouseover",this._onDropDownHoverDelegate);
$removeHandler(this.get_childListElement(),"mouseout",this._onDropDownOutDelegate);
$removeHandler(this.get_childListElement(),"selectstart",this._cancelEvent);
$removeHandler(this.get_childListElement(),"dragstart",this._cancelEvent);
}
if(this.get_tableElement()){
$removeHandler(this.get_tableElement(),"mouseover",this._onTableHoverDelegate);
$removeHandler(this.get_tableElement(),"mouseout",this._onTableOutDelegate);
}
if(this.get_imageDomElement()){
$removeHandler(this.get_imageDomElement(),"click",this._onImageClickDelegate);
}
if(this._openDropDownOnLoad){
$removeHandler(window,"load",this._onOpenOnLoad);
}
if(this.get_moreResultsBoxElement()){
$removeHandler(this.get_moreResultsBoxElement(),"click",this._onMoreResultsBoxClickDelegate);
$removeHandler(this.get_moreResultsBoxElement(),"mouseover",this._onMoreResultsBoxOverDelegate);
$removeHandler(this.get_moreResultsBoxElement(),"mouseout",this._onMoreResultsBoxOutDelegate);
}
$removeHandler(this.get_childListElementWrapper(),"scroll",this._onDropDownScrollDelegate);
if(this._slide){
this._slide.dispose();
this._slide=null;
}
},_cancelEvent:function(e){
e.preventDefault();
return false;
},_onDropDownScroll:function(e){
if(!this._virtualScroll||this._ajaxRequest||this._endOfItems){
return;
}
var _28=this.get_items().get_count();
var _29=22;
var _2a=0;
if(_28>0){
_29=this.get_items().getItem(0).get_element().offsetHeight;
_2a=this.get_items().getItem(_28-1).get_element().offsetTop;
}
var _2b=$telerik.getFirstChildByTagName(this.get_childListElement(),"div",0);
if(_2b){
var _2c=_2b.offsetHeight;
if(this.get_childListElementWrapper().scrollTop+_2c>=this.get_childListElement().offsetHeight-_2c){
this.requestItems(this.get_text(),true);
}
}
},_initOriginalDomPositionHelper:function(){
this._originalDomPositionHelper=document.createElement("div");
this._originalDomPositionHelper.style.display="none";
var _2d=this.get_dropDownElement().parentNode;
_2d.parentNode.insertBefore(this._originalDomPositionHelper,_2d);
},_detachDropDown:function(){
if(!this._originalDomPositionHelper){
this._initOriginalDomPositionHelper();
}
if((!document.readyState||document.readyState=="complete")&&(!this._isDetached)){
var _2e=this._findParentForm();
var _2f=this.get_dropDownElement();
var _30=this.get_dropDownElement().parentNode;
_30.parentNode.removeChild(_30);
_30.style.marginLeft="0";
_2e.insertBefore(_30,_2e.firstChild);
this._isDetached=true;
}
},_attachDropDown:function(){
if(this._isDetached){
var _31=this.get_dropDownElement();
var _32=this.get_dropDownElement().parentNode;
_32.parentNode.removeChild(_32);
_32.style.marginLeft="0";
this._originalDomPositionHelper.parentNode.insertBefore(_32,this._originalDomPositionHelper);
this._isDetached=false;
_32.style.display="none";
}
},_onEndRequest:function(_33,_34){
this._isInPostBack=false;
},_backUpDropDown:function(){
this._attachDropDown();
this._isInPostBack=true;
},_findParentForm:function(){
var _35=this.get_element();
while(_35.tagName.toLowerCase()!="form"){
_35=_35.parentNode;
}
return _35;
},_findNearestItem:function(_36){
while(_36.nodeType!==9){
if(_36._item&&Telerik.Web.UI.RadComboBoxItem.isInstanceOfType(_36._item)){
return _36._item;
}
_36=_36.parentNode;
}
return null;
},_positionDropDown:function(){
this._detachDropDown();
var _37=this.get_element();
var _38=this._getAnimationContainer();
_38.style.position="absolute";
var _39=$telerik.getLocation(_37);
var _3a=this.get_dropDownElement();
var _3b=this.get_element().offsetWidth;
if(this._dropDownWidth){
_3b=this._dropDownWidth;
}
var _3c=this.get_childListElement();
var _3d=this.get_childListElementWrapper();
var _3e=_39.y+this.get_offsetY()+this.get_element().offsetHeight;
_38.style.top=_3e+"px";
_38.style.left=_39.x+this.get_offsetX()+"px";
if(this._rightToLeft&&document.body.dir=="rtl"){
_38.style.left="";
_38.style.left=_39.x+this.get_offsetX()-this._getScrollBarWidth()+"px";
}
_3a.style.display="block";
_3a.style.width=_3b+"px";
var _3f=0;
if(!this._dropDownWidth){
_3f=_3a.offsetWidth-_3b;
}
if(_3f>0&&_3f<_3b){
_3a.style.width=_3b-_3f+"px";
}
if(this._rightToLeft){
_3a.dir="rtl";
}
this._determineScreenBoundaryDetection();
},_calculateDropDownAutoHeight:function(){
var _40=this.get_dropDownElement();
var _41=this._getAnimationContainer();
var _42=$telerik.getLocation(this.get_element());
var _41=this._getAnimationContainer();
var _43=$telerik.getLocation(_41);
var _44=$telerik.getViewPortSize();
var y=_42.y-_40.offsetHeight;
var _46=_44.height-_43.y;
var _47=_43.y-this.get_element().offsetHeight;
var _48=_46;
var _49=false;
var _4a=0;
if(this._getHeaderElement()){
_4a=_4a+this._getHeaderElement().offsetHeight;
_49=true;
}
if(this.get_moreResultsBoxElement()){
_4a=_4a+this.get_moreResultsBoxElement().offsetHeight;
_49=true;
}
if(this._enableScreenBoundaryDetection&&_46<_47){
_48=_47;
}
if(!(_48>=0&&(this.get_childListElement().offsetHeight+_4a)>=_48)){
_48=this.get_childListElement().offsetHeight+_4a;
}
if(_49&&_4a<_48){
this.get_childListElementWrapper().style.height=_48-_4a+"px";
}else{
this.get_childListElementWrapper().style.height=_48+"px";
}
return _48;
},_determineScreenBoundaryDetection:function(){
var _4b=this.get_dropDownElement();
var _4c=this._getAnimationContainer();
var _4d=$telerik.getLocation(this.get_element());
var _4c=this._getAnimationContainer();
var _4e=$telerik.getLocation(_4c);
var _4f=$telerik.getViewPortSize();
var _50=_4b.offsetHeight;
if(this._height==""&&this.get_childListElement()){
_50=this._calculateDropDownAutoHeight();
}
if(this._enableScreenBoundaryDetection){
if(this._elementOverflowsBottom(_4f,_4b,this.get_inputDomElement())){
var y=_4d.y-_50;
if(y>=0){
this.set_slideDirection(Telerik.Web.UI.SlideDirection.Up);
this._getAnimationContainer().style.height=this.get_dropDownElement().offsetHeight;
this._getAnimationContainer().style.top=_4d.y-this.get_offsetY()-_4b.offsetHeight+"px";
if(window.netscape&&!window.opera){
this._getAnimationContainer().style.top=_4d.y-this.get_offsetY()-_4b.offsetHeight+2+"px";
}
if(this._height==""&&_50==_4e.y-this.get_element().offsetHeight){
this._getAnimationContainer().style.top="0px";
}
}else{
this.set_slideDirection(Telerik.Web.UI.SlideDirection.Down);
}
}else{
this.set_slideDirection(Telerik.Web.UI.SlideDirection.Down);
}
}
this.set_dropDownVisible(true);
},_getScrollBarWidth:function(){
var _52,_53=0;
var _54=document.createElement("div");
_54.style.position="absolute";
_54.style.top="-1000px";
_54.style.left="-1000px";
_54.style.width="100px";
_54.style.height="50px";
_54.style.overflow="hidden";
var _55=document.createElement("div");
_55.style.width="100%";
_55.style.height="200px";
_54.appendChild(_55);
document.body.appendChild(_54);
var _56=_55.offsetWidth;
_54.style.overflow="auto";
var _57=_55.offsetWidth;
this._scrollbarWidth=_56-_57;
if(this._scrollbarWidth<=0){
_55.style.width="300px";
_52=_54.offsetWidth;
_53=_54.clientWidth;
this._scrollbarWidth=_52-_53;
}
if(this._scrollbarWidth<=0){
this._scrollbarWidth=16;
}
document.body.removeChild(document.body.lastChild);
return this._scrollbarWidth;
},_elementOverflowsBottom:function(_58,_59,_5a){
var _5b=$telerik.getLocation(_5a).y+_59.offsetHeight;
return _5b>_58.height;
},_selectFirstMatch:function(){
var _5c=this._findItemToSelect();
if(_5c&&_5c.get_enabled()&&!_5c.get_isSeparator()){
_5c.highlight();
_5c.scrollOnTop();
this.set_selectedItem(_5c);
}
},_findItemToSelect:function(){
var _5d=this.findItemByValue(this.get_value());
if(!_5d){
_5d=this.findItemByText(this.get_text());
}
return _5d;
},clearItems:function(){
this.get_items().clear();
},clearSelection:function(){
this.set_text("");
this.set_value("");
this.set_selectedItem(null);
this.set_highlightedItem(null);
},_findNextAvailableIndex:function(_5e,_5f){
var _60=this.get_items();
for(var i=_5e;i<_60.get_count();i++){
if(_60.getItem(i).get_enabled()&&!_60.getItem(i).get_isSeparator()){
if(_5f==null){
return i;
}
if(_5f&&_60.getItem(i).get_text().indexOf(_5f)==0){
return i;
}
}
}
return _60.get_count();
},_findPrevAvailableIndex:function(_62){
var _63=this.get_items();
if(_63.get_count()<1){
return -1;
}
for(var i=_62;i>=0;i--){
if(_63.getItem(i).get_enabled()&&!_63.getItem(i).get_isSeparator()){
return i;
}
}
return -1;
},_onDropDownClick:function(e){
if(!this._enabled){
return;
}
var _66=this._findNearestItem(e.target);
if(!_66||!_66.get_enabled()||_66.get_isSeparator()){
return;
}
this._hideDropDown(e);
this._performSelect(_66);
},_onDropDownHover:function(e){
if(!this._enabled||this._ajaxRequest){
return;
}
var _68=this._findNearestItem(e.target);
if(!_68||!_68.get_enabled()||_68.get_isSeparator()){
return;
}
_68.highlight();
},_onDropDownOut:function(e){
if(!this._enabled){
return;
}
if(!e){
e=event;
}
var _6a;
try{
_6a=e.toElement||e.relatedTarget||e.fromElement;
while(_6a.nodeType!==9){
if(_6a.parentNode==this.get_dropDownElement()){
return;
}
_6a=_6a.parentNode;
}
}
catch(e){
}
var _6b=this.get_highlightedItem();
if(_6b){
_6b.unHighlight();
}
},_onTableHover:function(e){
if(!this._enabled){
return;
}
var _6d=this.get_tableElement();
if(_6d!=null&&_6d.className!="rcbFocused"){
_6d.className="rcbHovered";
}
},_onTableOut:function(e){
if(!this._enabled){
return;
}
if(!e){
e=event;
}
var _6f=this.get_tableElement();
var _70=e.target||e.srcElement;
var _71=e.toElement||e.relatedTarget||e.fromElement;
while(_71&&_71.nodeType!==9){
if(_71.parentNode&&_71.parentNode==_6f){
return;
}
_71=_71.parentNode;
}
if(_6f!=null&&_6f.className=="rcbHovered"){
_6f.className="";
}
},_onDocumentClick:function(e){
if(!e){
e=event;
}
var _73=e.target||e.srcElement;
while(_73.nodeType!==9){
if(_73.parentNode==null||_73==this.get_element()||_73==this.get_dropDownElement()){
return;
}
_73=_73.parentNode;
}
if(this.get_dropDownVisible()&&this.get_closeDropDownOnBlur()){
this._hideDropDown(e);
}
if(this._focused){
this._raiseClientBlur(e);
this._selectItemOnBlur();
this._focused=false;
}
},_selectItemOnBlur:function(){
var _74=this._findItemToSelect();
if(!_74&&!this.get_allowCustomText()&&this.get_items().get_count()>0){
if(this.get_markFirstMatch()){
if(this.get_text()==""){
this.set_text(this._originalText);
}
this.highlightMatches();
this.selectText(0,0);
_74=this.get_highlightedItem();
}
}
this._performSelect(_74);
},_onWindowResize:function(){
if(this.get_dropDownVisible()){
this._positionDropDown();
}
},_onKeyDown:function(e){
if(!this._fireEvents||this._ajaxRequest){
return;
}
if(!e){
e=event;
}
this.raise_onClientKeyPressing(e);
var _76=e.keyCode||e.which;
this._lastKeyCode=_76;
var _77=String.fromCharCode(_76);
if(_76==Telerik.Web.UI.Keys.Escape&&this.get_dropDownVisible()){
if(this.get_dropDownVisible()){
this._hideDropDown(e);
}
return;
}
if(_76===Telerik.Web.UI.Keys.Enter){
if(this.get_dropDownVisible()){
this._hideDropDown(e);
}
this._performSelect(this.get_highlightedItem());
e.returnValue=false;
if(e.preventDefault){
e.preventDefault();
}
return;
}else{
if(_76===Telerik.Web.UI.Keys.Down){
e.returnValue=false;
if(e.altKey){
this._toggleDropDown(e);
return;
}
this.highlightNextItem(null);
return;
}else{
if(_76===Telerik.Web.UI.Keys.Up){
e.returnValue=false;
if(e.altKey){
this._toggleDropDown(e);
return;
}
this.highlightPreviousItem();
return;
}else{
if(_76===Telerik.Web.UI.Keys.Tab){
if(this.get_dropDownVisible()){
this._hideDropDown(e);
}
this._raiseClientBlur(e);
this._selectItemOnBlur();
this._focused=false;
return;
}
}
}
}
if(_76==Telerik.Web.UI.Keys.Left||_76==Telerik.Web.UI.Keys.Right){
return;
}
if(_77&&!(this.get_markFirstMatch()||this.get_enableLoadOnDemand()||this.get_allowCustomText())){
this.highlightNextItem(_77);
return;
}
},_onImageClick:function(e){
if(this._enabled){
this._selectFirstMatch();
this._toggleDropDown(e);
}
},_onInputClick:function(e){
if(this._enabled){
this._selectFirstMatch();
this.selectText(0,this.get_text().length);
if(!this.get_dropDownVisible()&&this._showDropDownOnTextboxClick){
this._showDropDown(e);
}
return true;
}
},_onMoreResultsBoxClick:function(e){
this.requestItems(this.get_text(),true);
},_onMoreResultsBoxOver:function(e){
this.get_moreResultsBoxElement().style.cursor="pointer";
},_onMoreResultsBoxOut:function(e){
this.get_moreResultsBoxElement().style.cursor="default";
},_onFocus:function(e){
if(this._focused){
return;
}
if(this.get_emptyMessage()&&this.get_emptyMessage()==this.get_text()){
this._suppressChange=true;
this.get_inputDomElement().value=this._text;
this.get_inputDomElement().className="rcbInput";
this._suppressChange=false;
}
var _7e=this.get_tableElement();
if(_7e!=null){
_7e.className="rcbFocused";
}
if(!e){
e=event;
}
this._focused=true;
this.raise_onClientFocus(e);
return true;
},_raiseClientBlur:function(e){
if(this._focused){
var _80=this.get_tableElement();
if(_80!=null){
_80.className="";
}
this._applyEmptyMessage();
this.raise_onClientBlur(e);
}
},_applyEmptyMessage:function(){
if(this.get_emptyMessage()&&this.get_text()==""){
this._suppressChange=true;
this.get_inputDomElement().value=this.get_emptyMessage();
this.get_inputDomElement().className+=" rcbEmptyMessage";
this._suppressChange=false;
}
},_onInputChange:function(){
this.set_value("");
var _81=this.get_text();
if(this.get_emptyMessage()!=""&&_81!=this.get_emptyMessage()){
this._text=_81;
}
this.get_element().value=this._text;
this.updateClientState();
if(this.get_enableLoadOnDemand()&&!this._suppressChange){
var me=this;
if(this._requestTimeoutID>0){
window.clearTimeout(this._requestTimeoutID);
this._requestTimeoutID=0;
}
if(!this._showDropDownOnTextboxClick){
this._skipLoadingItems=true;
}
if(!this.get_dropDownVisible()){
this.showDropDown();
}
this._requestTimeoutID=window.setTimeout(function(){
if(me._isInPostBack){
return;
}
me.requestItems(me.get_text(),false);
},me.get_itemRequestTimeout());
return;
}
if(!this._suppressChange&&this._shouldHighlight()){
this.highlightMatches();
}
},_onInputPropertyChange:function(){
if(event.propertyName=="value"){
var _83=this.get_text();
if(this._cachedText!=_83){
this._cachedText=_83;
this._onInputChange();
}
}
},_shouldHighlight:function(){
if(this._lastKeyCode<Telerik.Web.UI.Keys.Space){
return false;
}
if(this._lastKeyCode>=Telerik.Web.UI.Keys.PageUp&&this._lastKeyCode<=Telerik.Web.UI.Keys.Del){
return false;
}
if(this._lastKeyCode>=Telerik.Web.UI.Keys.F1&&this._lastKeyCode<=Telerik.Web.UI.Keys.F12){
return false;
}
return true;
},_showDropDown:function(e){
if(this._isInPostBack){
return;
}
if(this.raise_dropDownOpening(null)==true){
return;
}
var _85=this._getAnimationContainer();
if(!_85){
return;
}
var _86=this.get_text();
if(this.get_emptyMessage()==this.get_text()){
_86="";
}
if(this.get_enableLoadOnDemand()&&this.get_items().get_count()==0&&!this._skipLoadingItems){
this.requestItems(_86,false);
}
_85.style.visibility="hidden";
this.get_dropDownElement().style.visibility="hidden";
this._slide.show();
this._resetAnimatedElementPosition();
this._slide.set_direction(this.get_slideDirection());
this.get_inputDomElement().focus();
this._onFocus(e);
this.set_dropDownVisible(true);
this._positionDropDown();
var _87=this.get_dropDownElement();
_87.style.top=-_87.offsetHeight+"px";
this._slide.updateSize();
_85.style.visibility="visible";
this._slide.expand();
},_toggleDropDown:function(e){
if(this.get_dropDownVisible()){
this._hideDropDown(e);
}else{
this._showDropDown(e);
if(this.get_highlightedItem()){
this.get_highlightedItem().scrollIntoView();
}
}
},_hideDropDown:function(e){
if(this.raise_dropDownClosing(e)==true){
return;
}
this.get_dropDownElement().style.display="none";
if(!this._getAnimationContainer()){
return;
}
this._slide.collapse();
this.set_dropDownVisible(false);
},get_dropDownElement:function(){
if(!this._dropDownElement){
this._dropDownElement=this._getChildElement("DropDown");
}
return this._dropDownElement;
},get_inputDomElement:function(){
if(!this._inputDomElement){
this._inputDomElement=this._getChildElement("Input");
}
return this._inputDomElement;
},get_moreResultsBoxMessageElement:function(){
var box=this.get_moreResultsBoxElement();
var _8b=$telerik.getFirstChildByTagName(box,"span",0);
return _8b;
},get_moreResultsBoxElement:function(){
var box=this._getChildElement("MoreResultsBox");
return box;
},get_emptyMessage:function(){
return this._emptyMessage;
},set_emptyMessage:function(_8d){
if(this._emptyMessage!==_8d){
this._emptyMessage=_8d;
}
},get_imageDomElement:function(){
if(!this._imageDomElement){
this._imageDomElement=this._getChildElement("Arrow");
}
return this._imageDomElement;
},get_slideDirection:function(){
return this._slideDirection;
},set_slideDirection:function(_8e){
this._slideDirection=_8e;
this._slide.set_direction(_8e);
},hideDropDown:function(){
this._hideDropDown(null);
},showDropDown:function(){
this._showDropDown(null);
},toggleDropDown:function(){
this._toggleDropDown(null);
},_resetAnimatedElementPosition:function(){
var _8f=this._getAnimatedElement();
_8f.style.top="0px";
_8f.style.left="0px";
},_performSelect:function(_90){
if(_90&&_90!=this.get_selectedItem()&&!this.get_enableLoadOnDemand()){
_90.select();
return;
}
if(_90&&_90==this.get_selectedItem()&&this.get_text()!=_90.get_text()&&this.get_allowCustomText()){
this.set_text(_90.get_text());
return;
}
if(_90&&_90==this.get_selectedItem()){
return;
}
if(_90&&this.get_originalText()!=_90.get_text()){
_90.select();
return;
}
if(_90&&(!this.get_selectedItem()||this.get_selectedItem().get_value()!=_90.get_value())){
_90.select();
return;
}
if(this.get_originalText()!=this.get_text()){
if(this.get_highlightedItem()){
this.get_highlightedItem().unHighlight();
}
var _91={Command:"TextChanged"};
this.postback(_91);
}
},set_value:function(_92){
this._value=_92;
this.updateClientState();
},get_value:function(){
return this._value;
},set_text:function(_93){
this.get_element().value=_93;
this._suppressChange=true;
var _94=this.get_inputDomElement();
_94.value=_93;
this.set_value("");
if(_94.fireEvent){
var _95=document.createEventObject();
_94.fireEvent("onchange",_95);
}else{
if(_94.dispatchEvent){
var _96=true;
var _95=document.createEvent("HTMLEvents");
_95.initEvent("change",_96,true);
_94.dispatchEvent(_95);
}
}
this._suppressChange=false;
this._text=_93;
this.updateClientState();
},get_webServiceSettings:function(){
return this._webServiceSettings;
},set_webServiceSettings:function(_97){
var _98=Sys.Serialization.JavaScriptSerializer.deserialize(_97);
this._webServiceSettings=new Telerik.Web.UI.WebServiceSettings(_98);
},get_text:function(){
return this.get_inputDomElement().value;
},enable:function(){
this.get_inputDomElement().disabled=false;
var _99=this.get_tableElement();
if(_99!=null){
_99.className="";
}
this.set_enabled(true);
this.enableEvents();
var _9a=this._children.get_count();
for(var i=0;i<_9a;i++){
this._children.getItem(i).enable();
}
},disable:function(){
var _9c=this.get_tableElement();
if(_9c!=null){
_9c.className="rcbDisabled";
}
this.set_enabled(false);
this.set_value(this.get_text());
this.get_inputDomElement().disabled="disabled";
this.disableEvents();
var _9d=this._children.get_count();
for(var i=0;i<_9d;i++){
this._children.getItem(i).disable();
}
},set_enabled:function(_9f){
this._enabled=_9f;
this.updateClientState();
},get_enabled:function(){
return this._enabled;
},disableEvents:function(){
this._fireEvents=false;
},enableEvents:function(){
this._fireEvents=true;
},findItemByText:function(_a0){
var _a1=this.get_items();
for(var i=0;i<_a1.get_count();i++){
if(_a1.getItem(i).get_text()==_a0){
return _a1.getItem(i);
}
}
return null;
},findItemByValue:function(_a3){
if(!_a3){
return null;
}
var _a4=this.get_items();
for(var i=0;i<_a4.get_count();i++){
if(_a4.getItem(i).get_value()==_a3){
return _a4.getItem(i);
}
}
return null;
},_getAnimationContainer:function(){
if(!this._animationContainer){
if(this.get_dropDownElement()){
this._animationContainer=this.get_dropDownElement().parentNode;
}
}
return this._animationContainer;
},highlightPreviousItem:function(){
var _a6=this.get_items();
var _a7=this.get_highlightedItem();
var _a8=0;
if(_a7){
_a8=_a7.get_index()-1;
}
_a8=this._findPrevAvailableIndex(_a8);
if(_a8>=0){
_a6.getItem(_a8).highlight();
_a6.getItem(_a8).scrollIntoView();
var _a9=this._getLastSeparatorIndex(this.get_text());
var _aa=this.get_text().substring(0,_a9+1)+_a6.getItem(_a8).get_text();
if(this.get_changeText()){
this.set_text(_aa);
this.set_value(_a6.getItem(_a8).get_value());
}
}
},highlightNextItem:function(_ab){
var _ac=this.get_items();
var _ad=this.get_highlightedItem();
var _ae=0;
if(_ad){
_ae=_ad.get_index()+1;
}
_ae=this._findNextAvailableIndex(_ae,_ab);
if(_ab&&_ae==_ac.get_count()){
_ae=this._findNextAvailableIndex(0,_ab);
}
if(_ae<_ac.get_count()){
_ac.getItem(_ae).highlight();
_ac.getItem(_ae).scrollIntoView();
var _af=this._getLastSeparatorIndex(this.get_text());
var _b0=this.get_text().substring(0,_af+1)+_ac.getItem(_ae).get_text();
if(this.get_changeText()){
this.set_text(_b0);
this.set_value(_ac.getItem(_ae).get_value());
}
}
},findFirstMatch:function(_b1){
if(!_b1){
return null;
}
var _b2=this.get_items();
for(var i=0;i<_b2.get_count();i++){
if(_b2.getItem(i).get_text().length<_b1.length){
continue;
}
if(_b2.getItem(i).get_enabled()==false||_b2.getItem(i).get_isSeparator()){
continue;
}
var _b4=_b2.getItem(i).get_text().substring(0,_b1.length);
if(!this.get_isCaseSensitive()){
if(_b4.toLowerCase()==_b1.toLowerCase()){
return _b2.getItem(i);
}
}else{
if(_b4==_b1){
return _b2.getItem(i);
}
}
}
return null;
},highlightMatches:function(){
if(!this.get_markFirstMatch()){
return;
}
var _b5=this.get_text();
var _b6=this.getLastWord(_b5);
if(this._getLastSeparator(_b5)==_b5.charAt(_b5.length-1)){
return;
}
var _b7=this.findFirstMatch(_b6);
if(this.get_highlightedItem()){
this.get_highlightedItem().unHighlight();
}
if(!_b7){
if(!this.get_allowCustomText()){
if(_b5){
var _b8=this._getLastSeparatorIndex(_b5);
if(_b8<_b5.length-1){
this.set_text(_b5.substring(0,_b5.length-1));
this.highlightMatches();
}
}
}
return;
}
_b7.highlight();
_b7.scrollOnTop();
var _b8=this._getLastSeparatorIndex(_b5);
var _b9=_b5.substring(0,_b8+1)+_b7.get_text();
if(_b5!=_b9){
this.set_text(_b9);
}
this.set_value(_b7.get_value());
var _ba=_b8+_b6.length+1;
var _bb=_b9.length-_ba;
this.selectText(_ba,_bb);
},postback:function(_bc){
if(!this._postBackReference){
return;
}
var _bd=this._postBackReference.replace("arguments",Sys.Serialization.JavaScriptSerializer.serialize(_bc));
eval(_bd);
},_getLastSeparator:function(_be){
if(!this.get_autoCompleteSeparator()){
return null;
}
var _bf=this._getLastSeparatorIndex(_be);
return _be.charAt(_bf);
},getLastWord:function(_c0){
var _c1=-1;
if(this.get_autoCompleteSeparator()!=null){
_c1=this._getLastSeparatorIndex(_c0);
}
var _c2=_c0.substring(_c1+1,_c0.length);
return _c2;
},_getLastSeparatorIndex:function(_c3){
var _c4=-1;
if(!this.get_autoCompleteSeparator()){
return _c4;
}
for(var i=0;i<this.get_autoCompleteSeparator().length;i++){
var _c6=this.get_autoCompleteSeparator().charAt(i);
var _c7=_c3.lastIndexOf(_c6);
if(_c7>_c4){
_c4=_c7;
}
}
return _c4;
},selectText:function(_c8,_c9){
if(this.get_inputDomElement().createTextRange){
var _ca=this.get_inputDomElement().createTextRange();
if(_c8==0&&_c9==0){
_ca.collapse(true);
return;
}
_ca.moveStart("character",_c8);
_ca.moveEnd("character",_c9);
_ca.select();
}else{
this.get_inputDomElement().setSelectionRange(_c8,_c8+_c9);
}
},_childRemoved:function(_cb,_cc){
var _cd=_cb.get_element();
if(_cb==this.get_selectedItem()){
this.set_selectedItem(null);
this.set_highlightedItem(null);
this.set_text("");
}
if(_cc.get_items().get_count()==0&&!this._getHeaderElement()){
_cd=_cc._childListElement;
_cc._childListElement=null;
}
if(_cd){
_cd.innerHTML="";
if(_cd.parentNode){
_cd.parentNode.removeChild(_cd);
}
_cd=null;
}
Telerik.Web.UI.RadComboBox.callBaseMethod(this,"_childRemoved",[_cb,_cc]);
},_childrenCleared:function(_ce){
this.set_selectedItem(null);
this.set_highlightedItem(null);
var _cf=_ce.get_childListElement();
if(_cf&&!this._getHeaderElement()){
for(var i=0;i<_ce.get_items().get_count();i++){
_ce.get_items().getItem(i)._dispose();
}
_cf.innerHTML="";
_cf=null;
}else{
if(_cf){
for(var i=0;i<_ce.get_items().get_count();i++){
this._childRemoved(_ce.get_items().getItem(i),_ce);
}
}
}
},_createChildControls:function(){
this._children=new Telerik.Web.UI.RadComboBoxItemCollection(this);
Telerik.Web.UI.RadComboBox._createChildControls(this,this._children);
},_createChildListElement:function(){
var _d1=document.createElement("ul");
_d1.className="rcbList";
this.get_childListElementWrapper().appendChild(_d1);
this._onDropDownClickDelegate=Function.createDelegate(this,this._onDropDownClick);
$addHandler(this.get_childListElement(),"click",this._onDropDownClickDelegate);
this._onDropDownHoverDelegate=Function.createDelegate(this,this._onDropDownHover);
$addHandler(this.get_childListElement(),"mouseover",this._onDropDownHoverDelegate);
$addHandler(this.get_childListElement(),"selectstart",this._cancelEvent);
$addHandler(this.get_childListElement(),"dragstart",this._cancelEvent);
this._onDropDownOutDelegate=Function.createDelegate(this,this._onDropDownOut);
$addHandler(this.get_childListElement(),"mouseout",this._onDropDownOutDelegate);
},get_childListElement:function(){
if(!this._childListElement){
var _d2=this.get_childListElementWrapper();
this._childListElement=$telerik.getFirstChildByTagName(_d2,"ul",0);
}
return this._childListElement;
},get_childListElementWrapper:function(){
if(!this._childListElementWrapper){
var _d3=this.get_dropDownElement();
if(this._getHeaderElement()){
this._childListElementWrapper=$telerik.getFirstChildByTagName(_d3,"div",1);
}else{
this._childListElementWrapper=$telerik.getFirstChildByTagName(_d3,"div",0);
}
}
return this._childListElementWrapper;
},_getHeaderElement:function(){
if(this.get_dropDownElement()){
return $telerik.getChildByClassName(this.get_dropDownElement(),"rcbHeader",0);
}
return null;
},get_tableElement:function(){
if(!this._tableElement){
this._tableElement=$telerik.getFirstChildByTagName(this.get_element(),"table",0);
}
return this._tableElement;
},get_expandAnimation:function(){
return this._expandAnimation;
},set_expandAnimation:function(_d4){
var _d5=Sys.Serialization.JavaScriptSerializer.deserialize(_d4);
this._expandAnimation=new Telerik.Web.UI.AnimationSettings(_d5);
},get_collapseAnimation:function(){
return this._collapseAnimation;
},set_collapseAnimation:function(_d6){
var _d7=Sys.Serialization.JavaScriptSerializer.deserialize(_d6);
this._collapseAnimation=new Telerik.Web.UI.AnimationSettings(_d7);
},_getAnimatedElement:function(){
if(!this._animatedElement){
this._animatedElement=this.get_dropDownElement();
}
return this._animatedElement;
},get_items:function(){
return this._getChildren();
},set_items:function(_d8){
this._children=_d8;
},get_itemData:function(){
return this._itemData;
},set_itemData:function(_d9){
this._itemData=_d9;
},get_itemRequestTimeout:function(){
return this._itemRequestTimeout;
},set_itemRequestTimeout:function(_da){
this._itemRequestTimeout=_da;
},get_appendItems:function(){
return this._appendItems;
},set_appendItems:function(_db){
this._appendItems=_db;
},get_selectedItem:function(){
return this._selectedItem;
},set_selectedItem:function(_dc){
this._selectedItem=_dc;
},get_selectedIndex:function(){
var _dd=this.get_selectedItem();
if(_dd){
return _dd.get_index();
}
return this._selectedIndex;
},set_selectedIndex:function(_de){
this._selectedIndex=_de;
},get_causesValidation:function(){
return this._causesValidation;
},set_causesValidation:function(_df){
this._causesValidation=_df;
},get_closeDropDownOnBlur:function(){
return this._closeDropDownOnBlur;
},set_closeDropDownOnBlur:function(_e0){
this._closeDropDownOnBlur=_e0;
},get_isTemplated:function(){
return this._isTemplated;
},set_isTemplated:function(_e1){
this._isTemplated=_e1;
},get_highlightTemplatedItems:function(){
return this._highlightTemplatedItems;
},set_highlightTemplatedItems:function(_e2){
this._highlightTemplatedItems=_e2;
},get_enableLoadOnDemand:function(){
return this._enableLoadOnDemand;
},set_enableLoadOnDemand:function(_e3){
this._enableLoadOnDemand=_e3;
},get_allowCustomText:function(){
return this._allowCustomText;
},set_allowCustomText:function(_e4){
this._allowCustomText=_e4;
},get_changeText:function(){
return this._changeText;
},set_changeText:function(_e5){
this._changeText=_e5;
},get_markFirstMatch:function(){
return this._markFirstMatch;
},set_markFirstMatch:function(_e6){
this._markFirstMatch=_e6;
},get_originalText:function(){
return this._originalText;
},set_originalText:function(_e7){
this._originalText=_e7;
},get_highlightedItem:function(){
return this._highlightedItem;
},set_highlightedItem:function(_e8){
this._highlightedItem=_e8;
},get_isCaseSensitive:function(){
return this._isCaseSensitive;
},set_isCaseSensitive:function(_e9){
this._isCaseSensitive=_e9;
},get_dropDownVisible:function(){
return this._dropDownVisible;
},set_dropDownVisible:function(_ea){
this._dropDownVisible=_ea;
},get_autoCompleteSeparator:function(){
return this._autoCompleteSeparator;
},set_autoCompleteSeparator:function(_eb){
this._autoCompleteSeparator=_eb;
},get_showMoreMessage:function(){
return this._showMoreMessage;
},set_showMoreMessage:function(_ec){
this._showMoreMessage=_ec;
},get_loadingMessage:function(){
return this._loadingMessage;
},set_loadingMessage:function(_ed){
this._loadingMessage=_ed;
},get_errorMessage:function(){
return this._errorMessage;
},set_errorMessage:function(_ee){
this._errorMessage=_ee;
},set_endOfItems:function(_ef){
this._endOfItems=_ef;
},get_endOfItems:function(){
return this._endOfItems;
},get_clientDataString:function(){
return this._clientDataString;
},set_clientDataString:function(_f0){
this._clientDataString=_f0;
},get_offsetX:function(){
return this._offsetX;
},set_offsetX:function(_f1){
this._offsetX=_f1;
},get_offsetY:function(){
return this._offsetY;
},set_offsetY:function(_f2){
this._offsetY=_f2;
},add_keyPressing:function(_f3){
this.get_events().addHandler("keyPressing",_f3);
},remove_keyPressing:function(_f4){
this.get_events().removeHandler("keyPressing",_f4);
},raise_keyPressing:function(_f5){
this.raiseEvent("keyPressing",_f5);
},add_selectedIndexChanging:function(_f6){
this.get_events().addHandler("selectedIndexChanging",_f6);
},remove_selectedIndexChanging:function(_f7){
this.get_events().removeHandler("selectedIndexChanging",_f7);
},raise_selectedIndexChanging:function(_f8,e){
var _fa=new Telerik.Web.UI.RadComboBoxItemCancelEventArgs(_f8,e);
this.raiseEvent("selectedIndexChanging",_fa);
return _fa.get_cancel();
},add_selectedIndexChanged:function(_fb){
this.get_events().addHandler("selectedIndexChanged",_fb);
},remove_selectedIndexChanged:function(_fc){
this.get_events().removeHandler("selectedIndexChanged",_fc);
},raise_selectedIndexChanged:function(_fd,e){
var _ff=new Telerik.Web.UI.RadComboBoxItemEventArgs(_fd,e);
this.raiseEvent("selectedIndexChanged",_ff);
},add_itemsRequesting:function(_100){
this.get_events().addHandler("itemsRequesting",_100);
},remove_itemsRequesting:function(_101){
this.get_events().removeHandler("itemsRequesting",_101);
},add_itemsRequested:function(_102){
this.get_events().addHandler("itemsRequested",_102);
},remove_itemsRequested:function(_103){
this.get_events().removeHandler("itemsRequested",_103);
},raise_itemsRequested:function(text,e){
var _106=new Telerik.Web.UI.RadComboBoxRequestEventArgs(text,e);
this.raiseEvent("itemsRequested",_106);
},add_dropDownOpening:function(_107){
this.get_events().addHandler("dropDownOpening",_107);
},remove_dropDownOpening:function(_108){
this.get_events().removeHandler("dropDownOpening",_108);
},raise_dropDownOpening:function(e){
var _10a=new Telerik.Web.UI.RadComboBoxCancelEventArgs(e);
this.raiseEvent("dropDownOpening",_10a);
return _10a.get_cancel();
},add_dropDownClosing:function(_10b){
this.get_events().addHandler("dropDownClosing",_10b);
},remove_dropDownClosing:function(_10c){
this.get_events().removeHandler("dropDownClosing",_10c);
},add_itemsRequestFailed:function(_10d){
this.get_events().addHandler("itemsRequestFailed",_10d);
},remove_itemsRequestFailed:function(_10e){
this.get_events().removeHandler("itemsRequestFailed",_10e);
},raise_itemsRequestFailed:function(text,_110,e){
var _112=new Telerik.Web.UI.RadComboBoxItemsRequestFailedEventArgs(text,_110,e);
this.raiseEvent("itemsRequestFailed",_112);
return _112.get_cancel();
},raise_dropDownClosing:function(e){
var _114=new Telerik.Web.UI.RadComboBoxCancelEventArgs(e);
this.raiseEvent("dropDownClosing",_114);
return _114.get_cancel();
},add_onClientFocus:function(_115){
this.get_events().addHandler("onClientFocus",_115);
},remove_onClientFocus:function(_116){
this.get_events().removeHandler("onClientFocus",_116);
},raise_onClientFocus:function(e){
var _118=new Telerik.Web.UI.RadComboBoxEventArgs(e);
this.raiseEvent("onClientFocus",_118);
},add_onClientBlur:function(_119){
this.get_events().addHandler("onClientBlur",_119);
},remove_onClientBlur:function(_11a){
this.get_events().removeHandler("onClientBlur",_11a);
},raise_onClientBlur:function(e){
var _11c=new Telerik.Web.UI.RadComboBoxEventArgs(e);
this.raiseEvent("onClientBlur",_11c);
},add_onClientKeyPressing:function(_11d){
this.get_events().addHandler("keyPressing",_11d);
},remove_onClientKeyPressing:function(_11e){
this.get_events().removeHandler("keyPressing",_11e);
},raise_onClientKeyPressing:function(e){
var _120=new Telerik.Web.UI.RadComboBoxEventArgs(e);
this.raiseEvent("keyPressing",_120);
},add_load:function(_121){
this.get_events().addHandler("load",_121);
},remove_load:function(_122){
this.get_events().removeHandler("load",_122);
},_logInserted:function(item){
if(!item.get_parent()._childControlsCreated||!this._enableClientStatePersistence){
return;
}
this._log.logInsert(item);
},saveClientState:function(){
var _124=this._log._logEntries;
var _125={logEntries:_124,value:this._value,text:this._text,enabled:this._enabled};
return Sys.Serialization.JavaScriptSerializer.serialize(_125);
},requestItems:function(text,_127){
if(this._isInPostBack){
return;
}
text=text.replace(/'/g,"&squote");
text=encodeURIComponent(text);
this._ajaxRequest=true;
var _128={};
this.set_appendItems(_127);
var _129=new Telerik.Web.UI.RadComboBoxRequestCancelEventArgs(text,_128);
this.raiseEvent("itemsRequesting",_129);
if(_129.get_cancel()){
return;
}
if(this.get_highlightedItem()){
this.get_highlightedItem().unHighlight();
}
if(!this._loadingDiv){
this._loadingDiv=document.createElement("li");
this._loadingDiv.className="rcbLoading";
this._loadingDiv.id=this.get_id()+"_LoadingDiv";
this._loadingDiv.innerHTML=this.get_loadingMessage();
if(!this.get_childListElement()){
this._createChildListElement();
}
this.get_childListElement().insertBefore(this._loadingDiv,this.get_childListElement().firstChild);
}
_128.NumberOfItems=0;
if(this.get_appendItems()){
_128.NumberOfItems=this.get_items().get_count();
}
_128.Text=decodeURIComponent(text);
if(this.get_webServiceSettings().get_method()){
this._doLoadOnDemandFromWebService(text,_128);
}else{
this._doLoadOnDemand(text,_128);
}
},_doLoadOnDemand:function(text,_12b){
var _12c=0;
if(this.get_appendItems()){
_12c=this.get_items().get_count();
}
var _12d={Command:"LOD",Text:text,ClientState:this._clientState,Context:_12b,NumberOfItems:_12c};
var _12e=Function.createDelegate(this,this._onCallbackResponse);
var _12f=Function.createDelegate(this,this._onErrorReceived);
WebForm_DoCallback(this._uniqueId,Sys.Serialization.JavaScriptSerializer.serialize(_12d),_12e,text,_12f,true);
},_onCallbackResponse:function(_130){
this.set_selectedItem(null);
this.set_highlightedItem(null);
var _131=this._children.get_count();
var _132=_130.split("_$$_");
var _133;
if(_132[0]=="[]"){
_133=null;
}else{
_133=eval(_132[0]);
}
if(_132[3]=="True"){
this._endOfItems=true;
}else{
this._endOfItems=false;
}
if(this.get_appendItems()&&this._itemData&&_133){
Array.addRange(this._itemData,_133);
}else{
this._itemData=_133;
}
if(this._loadingDiv){
if(this._loadingDiv.parentNode){
this._loadingDiv.parentNode.removeChild(this._loadingDiv);
}
this._loadingDiv=null;
}
var _134=this.get_childListElement();
if(!_134){
_134=this._createChildListElement();
}
var _135=_134.innerHTML;
var _136=this._getHeaderElement();
this._childControlsCreated=true;
var _137=$telerik.getFirstChildByTagName(_134,"div",0);
if(_137){
_137.parentNode.removeChild(_137);
}
if(this.get_appendItems()){
var _138=document.createElement("ul");
_138.innerHTML=_132[1];
var _139=$telerik.getChildrenByTagName(_138,"li");
var _13a=_139.length;
for(var i=0;i<_139.length;i++){
_134.appendChild(_139[i]);
this._childControlsCreated=false;
var item=new Telerik.Web.UI.RadComboBoxItem();
this._children.add(item);
item._initialize(_133[i],_139[i]);
}
if(this._virtualScroll){
this._setUpScroll(this._endOfItems,_134);
}
if(this._children.getItem(_131+1)!=null){
if(this._virtualScroll){
this._virtualScroll=false;
this._children.getItem(_131+1).scrollIntoView();
this._virtualScroll=true;
}
}
}else{
this._children.clear();
if(_136){
_134.innerHTML=_134.innerHTML+_132[1];
}else{
_134.innerHTML=_132[1];
}
this._childControlsCreated=false;
this._createChildControls();
if(this._virtualScroll){
this._setUpScroll(this._endOfItems,_134);
}
}
if(this._showMoreResultsBox&&this.get_moreResultsBoxMessageElement()){
this.get_moreResultsBoxMessageElement().innerHTML=_132[2];
}
this.highlightMatches();
this.raise_itemsRequested(this.get_text(),null);
if(this.get_dropDownVisible()){
if(this._slide){
this._slide.updateSize();
}
this._positionDropDown();
}
this._ajaxRequest=false;
},_setUpScroll:function(_13d,_13e){
var _13f=22;
var _140=this.get_items().get_count();
if(_140>0){
_13f=this.get_items().getItem(0).get_element().offsetHeight;
}
if(_13d){
var _141=$telerik.getFirstChildByTagName(_13e,"div",0);
if(_141){
_141.parentNode.removeChild(_141);
}
}else{
var _141=document.createElement("div");
_141.style.height=this.get_childListElementWrapper().offsetHeight+"px";
_13e.appendChild(_141);
}
},_onErrorReceived:function(_142,text){
if(this._requestTimeoutID>0){
window.clearTimeout(this._requestTimeoutID);
this._requestTimeoutID=0;
}
var _144=this._extractErrorMessage(_142);
if(this.raise_itemsRequestFailed(text,_144,null)==true){
return;
}
alert(_144);
},_initializeWebServiceLoader:function(){
this._webServiceLoader=new Telerik.Web.UI.WebServiceLoader(this.get_webServiceSettings());
this._webServiceLoader.add_loadingSuccess(Function.createDelegate(this,this._onWebServiceResponse));
this._webServiceLoader.add_loadingError(Function.createDelegate(this,this._onWebServiceError));
},_doLoadOnDemandFromWebService:function(text,_146){
if(!this._webServiceLoader){
this._initializeWebServiceLoader();
}
var _147={context:_146};
this._webServiceLoader.loadData(_147,text);
},_onWebServiceResponse:function(_148,_149){
var _14a=_149.get_data();
var text=_149.get_context();
this.set_selectedItem(null);
this.set_highlightedItem(null);
var _14c=this.get_items().get_count();
this._childControlsCreated=true;
if(this._loadingDiv){
if(this._loadingDiv.parentNode){
this._loadingDiv.parentNode.removeChild(this._loadingDiv);
}
this._loadingDiv=null;
}
var _14d=this.get_childListElement();
if(!_14d){
_14d=this._createChildListElement();
}
if(!this.get_appendItems()){
this.clearItems();
}
if(this._virtualScroll){
this._setUpScroll(true,_14d);
}
var _14e=null;
if(Array.prototype.isPrototypeOf(_14a)){
_14e=_14a;
}else{
_14e=_14a.Items;
this._endOfItems=_14a.EndOfItems;
this._showMoreMessage=_14a.Message;
}
for(var i=0;i<_14e.length;i++){
var item=new Telerik.Web.UI.RadComboBoxItem();
var data=_14e[i];
item._loadFromDictionary(data);
this._children.add(item);
}
if(this._virtualScroll){
this._setUpScroll(this._endOfItems,_14d);
}
if(this.get_appendItems()){
if(this.get_items().getItem(_14c+1)!=null){
this.get_items().getItem(_14c+1).scrollIntoView();
}
}
if(this._showMoreResultsBox&&this.get_moreResultsBoxMessageElement()){
this.get_moreResultsBoxMessageElement().innerHTML=this.get_showMoreMessage();
}
this.raise_itemsRequested(text,null);
if(this._shouldHighlight()){
this.highlightMatches();
}
if(this.get_dropDownVisible()){
if(this._slide){
this._slide.updateSize();
}
this._positionDropDown();
}
this._ajaxRequest=false;
},_onWebServiceError:function(_152,_153){
var _154=_153.get_message();
var text=_153.get_context();
this._onErrorReceived(_154,text);
}};
Telerik.Web.UI.RadComboBox.registerClass("Telerik.Web.UI.RadComboBox",Telerik.Web.UI.ControlItemContainer);
Type.registerNamespace("Telerik.Web.UI");
Telerik.Web.UI.RadComboBoxItem=function(){
Telerik.Web.UI.RadComboBoxItem.initializeBase(this);
this._highlighted=false;
};
Telerik.Web.UI.RadComboBoxItem.prototype={_shouldInitializeChild:function(_156){
return false;
},_render:function(html){
html[html.length]="<li class='";
if(this.get_enabled()){
if(this.get_isSeparator()){
html[html.length]="rcbItem rcbSeparator'>";
}else{
html[html.length]="rcbItem'>";
}
}else{
html[html.length]="rcbDisabled'>";
}
html[html.length]=this.get_text();
html[html.length]="</li>";
},get_value:function(){
return this._properties.getValue("value","");
},select:function(){
if(!this.get_isEnabled()||this.get_isSeparator()){
return;
}
var _158=this.get_comboBox();
if(_158.raise_selectedIndexChanging(this,null)==true){
return;
}
var text=_158.get_text();
var _15a=_158._getLastSeparatorIndex(text);
var _15b=text.substring(0,_15a+1)+this.get_text();
_158.set_text(_15b);
_158.set_originalText(_15b);
_158.set_value(this.get_value());
_158.set_selectedItem(this);
_158.set_selectedIndex(this.get_index());
this.highlight();
_158.raise_selectedIndexChanged(this,null);
var _15c={Command:"Select",Index:this.get_index()};
_158.postback(_15c);
},_createChildControls:function(){
},unHighlight:function(){
var _15d=this.get_comboBox();
if(!_15d.get_isTemplated()||_15d.get_highlightTemplatedItems()){
this._replaceCssClass(this.get_element(),"rcbHovered","rcbItem");
}
_15d.set_highlightedItem(null);
this.set_highlighted(false);
},highlight:function(){
if(!this.get_isEnabled()||this.get_isSeparator()){
return;
}
var _15e=this.get_comboBox();
if(!_15e.get_isTemplated()||_15e.get_highlightTemplatedItems()){
var _15f=_15e.get_highlightedItem();
if(_15f){
_15f.unHighlight();
}
var _160=this.get_element();
if(_160){
this._replaceCssClass(_160,"rcbItem","rcbHovered");
}
}
_15e.set_highlightedItem(this);
this.set_highlighted(true);
},scrollOnTop:function(){
var _161=this.get_element().offsetTop;
var _162=this.get_comboBox();
var _163=_162._getHeaderElement();
if(_163){
_161=_161-_163.offsetHeight;
}
_162.get_childListElementWrapper().scrollTop=_161;
},scrollIntoView:function(){
var _164=this.get_element().offsetTop;
var _165=this.get_element().offsetHeight;
var _166=this.get_comboBox().get_childListElementWrapper();
var _167=_166.scrollTop;
var _168=_166.offsetHeight;
if(_164+_165>_167+_168){
_166.scrollTop=_164+_165-_168;
}else{
if(_164+_165<=_167){
_166.scrollTop=_164;
}
}
},nextItem:function(){
return this.get_comboBox().get_items().getItem(this.get_index()+1);
},_replaceCssClass:function(_169,_16a,_16b){
_169.className=_169.className.replace(_16a,_16b);
},_createChildListElement:function(){
var _16c=document.createElement("ul");
this.get_combobox().get_dropDownElement().appendChild(_16c);
},set_selected:function(_16d){
this._properties.setValue("selected",_16d);
},get_selected:function(){
return this._properties.getValue("selected",false);
},set_highlighted:function(_16e){
this._highlighted=_16e;
},get_highlighted:function(){
return this._highlighted;
},disable:function(){
this.set_enabled(false);
this.get_element().className="rcbDisabled";
},enable:function(){
this.set_enabled(true);
this.get_element().className="rcbItem";
},get_textElement:function(){
return this.get_element();
},get_comboBox:function(){
return this._parent;
},_getHierarchicalIndex:function(){
return this.get_index();
},get_isSeparator:function(){
return this._properties.getValue("isSeparator",false);
},set_isSeparator:function(_16f){
this._properties.setValue("isSeparator",_16f,true);
}};
Telerik.Web.UI.RadComboBoxItem.registerClass("Telerik.Web.UI.RadComboBoxItem",Telerik.Web.UI.ControlItem);
Type.registerNamespace("Telerik.Web.UI");
Telerik.Web.UI.RadComboBoxItemCollection=function(_170){
Telerik.Web.UI.RadComboBoxItemCollection.initializeBase(this,[_170]);
};
Telerik.Web.UI.RadComboBoxItemCollection.prototype={};
Telerik.Web.UI.RadComboBoxItemCollection.registerClass("Telerik.Web.UI.RadComboBoxItemCollection",Telerik.Web.UI.ControlItemCollection);

